# struct LLVM::Type

- LLVM::Type
- Struct
- Value
- Object

## Defined in:

## Constructors

- .function(arg_types : Array(LLVM::Type), return_type, varargs = false) : self
- .new(unwrap : LibLLVM::TypeRef)

## Instance Method Summary

- #array(count)
- #array_size
- #const_array(values : Array(LLVM::Value)) : Value
- #const_double(string : String) : Value
- #const_double(value : Float64) : Value
- #const_float(value : String) : Value
- #const_float(value : Float32) : Value
- #const_inline_asm(asm_string, constraints, has_side_effects = false, is_align_stack = false)
- #const_int(value) : Value
- #context : Context
- #element_type
- #inspect(io : IO) : Nil
- #int_width
- #kind
- #null
- #null_pointer
- #packed_struct?
- #params_size
- #params_types
- #pointer
- #return_type
- #size
- #struct_element_types
- #struct_name : String?

  Assuming this type is a struct, returns its name.

- #to_unsafe : LibLLVM::TypeRef
- #undef
- #unwrap : LibLLVM::TypeRef
- #varargs?
- #vector(count) : self
- #vector_size
- #void?

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.function(arg_types : Array(LLVM::Type), return_type, varargs = false) : self #
def self.new(unwrap : LibLLVM::TypeRef) #

## Instance Method Detail

def array(count) #
def array_size #
def const_array(values : Array(LLVM::Value)) : Value #
def const_double(string : String) : Value #
def const_double(value : Float64) : Value #
def const_float(value : String) : Value #
def const_float(value : Float32) : Value #
def const_inline_asm(asm_string, constraints, has_side_effects = false, is_align_stack = false) #
def const_int(value) : Value #
def context : Context #
def element_type #
def inspect(io : IO) : Nil #
def int_width #
def kind #
def null #
def null_pointer #
def packed_struct? #
def params_size #
def params_types #
def pointer #
def return_type #
def size #
def struct_element_types #
def struct_name : String? #

Assuming this type is a struct, returns its name. The name can be `nil` if the struct is anonymous. Raises if this type is not a struct.

def to_unsafe : LibLLVM::TypeRef #
def undef #
def unwrap : LibLLVM::TypeRef #
def varargs? #
def vector(count) : self #
def vector_size #
def void? #